﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using WpfTest.Model;

namespace WpfTest
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            //drawProfile();          //画原始点
            //drawProfileLines();   //原始点连线
            //drawScaleProfile();     //画补间点
            //drawApprLine();         //画近似线
            //drawApprline2();        //画新近似线
        }
        /// <summary>
        /// 画点函数
        /// </summary>
        public void DrawPoint(Point p,SolidColorBrush s)
        {
            //LineGeometry line = new LineGeometry();
            //line.StartPoint = p;
            //line.EndPoint = new Point(100,100);

            EllipseGeometry el = new EllipseGeometry();
            el.Center = p;
            el.RadiusX = 0.5;
            el.RadiusY = 0.5;
            
            Path mypath = new Path();
            mypath.Stroke = s;
            mypath.StrokeThickness = 1;
            mypath.Data = el;

            panelCanvas.Children.Add(mypath);
            
        }
        /// <summary>
        /// 画线
        /// </summary>
        public void drawline(Point startPoint,Point endPoint,SolidColorBrush s)
        {
            LineGeometry line = new LineGeometry();
            line.StartPoint = startPoint;
            line.EndPoint = endPoint;

            Path mypath = new Path();
            mypath.Stroke = s;
            mypath.StrokeThickness = 1;
            mypath.Data = line;

            panelCanvas.Children.Add(mypath);
        }
        /// <summary>
        /// 画多个点
        /// </summary>
        public void drawPoints()
        {
            Random rand = new Random();
            for(int i=1;i<450;i++)
            {
                Point p = new Point(i,rand.Next(i,i+50));
                DrawPoint(p,Brushes.Blue);
            }
        }
        /// <summary>
        /// 画多条线
        /// </summary>
        public void drawlines()
        {
            int x = 0;
            double y = -0.5 * x + 50;
            Random rand = new Random();
            for (int i = 1; i < 700; i++)
            {
                Point p1 = new Point(i, rand.Next(i, i + 50) + -0.8 * i + 5);
                Point p2 = new Point(i + 1, rand.Next(i + 1, i + 51) + -0.8 * i + 5);
                drawline(p1,p2,Brushes.Blue); 
            }
        }
        /// <summary>
        /// 画原始点
        /// </summary>
        public void drawProfile()
        {
            Profile profile = new Profile();
            Method m =new Method();
            profile = m.newSinProfile();
            double start = 0;
            for (int i = 0; i < profile.Values.Count; i++)
            {
                DrawPoint(new Point((start++) + profile.Interval ,profile.Values[i].Value),Brushes.Blue);
            }
        }
        /// <summary>
        /// 画原始点间连线
        /// </summary>
        public void drawProfileLines()
        {
            Profile profile = new Profile();
            Method m = new Method();
            profile = m.newSinProfile();
            
            for (int i = 0; i < profile.Values.Count-1; i++)
            {
                Point p1 = new Point(i + profile.Interval, profile.Values[i].Value);
                Point p2 = new Point(i + profile.Interval +1, profile.Values[i+1].Value);
                drawline(p1,p2,Brushes.Green);
            }
        }
        /// <summary>
        /// 画补间点
        /// </summary>
        public void drawScaleProfile()
        {
            Profile profile = new Profile();
            Method m = new Method();
            profile = m.newSinProfile();
            ScaleProfile scaleProfile = new ScaleProfile();
            scaleProfile = Analyses.Interpolation(profile, double.Parse(interval.Text.Trim().ToString()), double.Parse(scaleZ.Text.Trim().ToString()));
            for (int i = 0; i < scaleProfile.Values.Count-1;i++ )
            {
                DrawPoint(new Point(scaleProfile.Values[i].ValueX,scaleProfile.Values[i].ValueZ),Brushes.Red);
                //Point p1 = new Point(scaleProfile.Values[i].ValueX,scaleProfile.Values[i].ValueZ);
                //Point p2 = new Point(scaleProfile.Values[i+1].ValueX, scaleProfile.Values[i+1].ValueZ);
                //drawline(p1, p2, Brushes.Red);
            }
        }
        /// <summary>
        /// 画近似线
        /// </summary>
        public void drawApprLine()
        {
            Profile profile = new Profile();
            Method m = new Method();
            profile = m.newSinProfile();
            ScaleProfile scaleProfile = new ScaleProfile();
            scaleProfile = Analyses.Interpolation(profile, double.Parse(interval.Text.Trim().ToString()), double.Parse(scaleZ.Text.Trim().ToString()));
            List<ApproximateLine> listappr = Analyses.FindApproximateLines(scaleProfile, int.Parse(PointCnt.Text.Trim().ToString()), int.Parse(overWrap.Text.Trim().ToString()));
            List<ApproximateLine> listappr1 = Analyses.ConnectLines(listappr, 100, 1);
            for (int i = 0; i < listappr.Count;i++ )
            {
               drawline(new Point(listappr[i].StartPnt.ValueX, listappr[i].StartPnt.ValueZ), new Point(listappr[i].EndPnt.ValueX, listappr[i].EndPnt.ValueZ), Brushes.Green);
            }
        }
        /// <summary>
        /// 画新近似线
        /// </summary>
        public void drawApprline2()
        {
            Profile profile = new Profile();
            Method m = new Method();
            profile = m.newSinProfile();
            ScaleProfile scaleProfile = new ScaleProfile();
            scaleProfile = Analyses.Interpolation(profile,double.Parse(interval.Text.Trim().ToString()), double.Parse(scaleZ.Text.Trim().ToString()));
            List<ApproximateLine> listappr = Analyses.FindApproximateLines(scaleProfile,int.Parse(PointCnt.Text.Trim().ToString()), int.Parse(overWrap.Text.Trim().ToString()));
            List<ApproximateLine> listappr1 = Analyses.ConnectLines(listappr, double.Parse(lineShred.Text.Trim().ToString()), double.Parse(horizenl.Text.Trim().ToString()));

            for (int i = 0; i < listappr1.Count; i++)
            {
                drawline(new Point(listappr1[i].StartPnt.ValueX, listappr1[i].StartPnt.ValueZ), new Point(listappr1[i].EndPnt.ValueX, listappr1[i].EndPnt.ValueZ), Brushes.Blue);
            }
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            this.panelCanvas.Children.Clear();
            drawProfile();
        }

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            this.panelCanvas.Children.Clear();
            drawScaleProfile();
        }

        private void Button_Click_2(object sender, RoutedEventArgs e)
        {
            this.panelCanvas.Children.Clear();
            drawApprLine();
        }

        private void Button_Click_3(object sender, RoutedEventArgs e)
        {
            this.panelCanvas.Children.Clear();
            drawApprline2();
        }
    }
}
